package arbre.quadtree;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.JFrame;
import javax.swing.JPanel;

public class Visualisation extends JFrame {

	private QuadTree quadTree;
	private int taille;
	
	public Visualisation(QuadTree quadTree, int taille){
		super("Visualisation");
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.quadTree = quadTree;
		this.taille = taille;
		this.add(new MonPanel());
		this.pack();
		this.setResizable(false);
		this.setVisible(true);
	}
	
	public class MonPanel extends JPanel
	{
		public MonPanel()
		{
			this.setPreferredSize(new Dimension(taille,taille));
			this.setSize(taille, taille);
		}

		@Override
		public void paint(Graphics g) {
			// TODO Auto-generated method stub
			super.paint(g);
			Graphics2D graphics2d = (Graphics2D) g;
			draw(graphics2d, quadTree, 0, 0, taille);
		}
		
	}
	
	
	private static void draw(Graphics2D g2, QuadTree q, int i, int j, int taille )
	{
		if (q.isLeaf()) 
		{
			g2.setColor(q.getValeur());
			g2.fillRect(i, j, taille, taille);
		}
		else
		{
			int ntaille = taille/2 ;
		      draw(g2, q.getNw(), i, j, ntaille) ;
		      draw(g2,q.getSw(), i, j+ntaille, ntaille) ;
		      draw(g2,q.getSe(), i+ntaille, j+ntaille, ntaille) ;
		      draw(g2, q.getNe(), i+ntaille, j, ntaille) ;
		}
			
	}
}
